
#include "appevent.ch"
#include "xbp.ch"
#include "gra.ch"
#include "common.ch"
#INCLUDE "dll.CH"

#define CRLF CHR(13)+CHR(10)

PROCEDURE AppSys()
RETURN

PROCEDURE main()
LOCAL oDlg, oPS, oSourcePS
LOCAL oDraw
LOCAL aSizeDesktop := AppDesktop():currentSize()
LOCAL nEvent := NIL, mp1 := NIL, mp2 := NIL, oObj := NIL
LOCAL aPos   := { 0,0 }
LOCAL aSize  := { 0,0 }
LOCAL aDraw  := { 0,0 }
LOCAL oStatic
LOCAL oBitmap
LOCAL oIcon
LOCAL nWait  := 10
LOCAL nXsize := 180
LOCAL nYsize := 80
LOCAL oThread := Thread():new()
LOCAL oBanner

   oBitmap  := XbpBitmap():new():create()
   oBitmap:load(,100)                            // mwb1024eve.bmp

   aSize[1] := oBitmap:xSize
   aSize[2] := oBitmap:ySize

   IF aSize[1]  > aSizeDesktop [1] -100
      aSize[1] := aSizeDesktop [1] -100
   ENDIF
   IF aSize[2]  > aSizeDesktop [2] -100
      aSize[2] := aSizeDesktop [2] -100
   ENDIF

   oDlg     := XbpDialog():new( AppDesktop(),, aPos, {0,0},, .F. )
   oDlg:taskList   := .T.
   oDlg:title      := "moving Bitmap over Bitmap"
   oDlg:border     := XBPDLG_RAISEDBORDERTHICK_FIXED
   oDlg:maxButton  := .F.
   oDlg:minButton  := .T.
   oDlg:Icon       := 1

   // use o:clientSize
   oDlg:clientSize := aSize
   // avoid flickering
   oDlg:drawingArea:clipChildren := .T.
   oDlg:create()

   aDraw    := oDlg:drawingArea:Currentsize()

   oStatic  := XbpStatic():new( oDlg:drawingArea,,{0,0},aDraw )
   oStatic:type    := XBPSTATIC_TYPE_BITMAP
   oStatic:caption := oBitmap
   oStatic:clipChildren := .T.
   oStatic:create()

* ------------------------------------------------------------------------- *

   // this Part is need to create a Banner using Parent Background (Bitmap)
   // and a 2nd Image for animation

   // Image to move on Banner
   oIcon    := XbpBitmap():new():create()        // YellowCab : taxi1.bmp
   oIcon:load(,101)
   oIcon:TransparentClr := oIcon:GetDefaultBGColor()

   nXsize := oIcon:Xsize
   nYsize := oIcon:Ysize

   // Banner to show Image
   oDraw    := XbpStatic():new( oStatic,,{0,0},{aDraw[1],nYsize} )
   oDraw:type     := XBPSTATIC_TYPE_BITMAP
   oDraw:drawMode := XBP_DRAW_OWNER
   oDraw:draw     := { |oPS, aInfo, oSelf| Test1(oPS, aInfo, oSelf,oBanner) }
   oDraw:Create()

   // Class Banner
   oBanner         := Banner():new(oDraw,,{0,0},{aDraw[1],nYsize} )
   oBanner:xPic    := oIcon
   oBanner:xLogo   := oBitmap
   oBanner:xBanner := oBitmap                    // need at Init
   oBanner:create()

   // start with empty Banner
   oDraw:SetCaption( oBanner:GetBG() )

   // use a Thread to update Banner
   oThread:start( {|| oBanner:Play(10) } )
   oThread:setInterval(nWait)

* ------------------------------------------------------------------------- *

   CenterControl(oDlg)
   SetAppWindow( oDlg )
   SetAppFocus( oDlg )
   oDlg:Show()

   nEvent := xbe_None
   DO WHILE nEvent != xbeP_Close
       nEvent := AppEvent ( @mp1, @mp2, @oObj, nWait )
       DO CASE
          CASE nEvent == xbe_None
*            oBanner:Play(10)

          CASE nEvent == xbeP_Keyboard .AND. mp1 == xbeK_ESC
             EXIT

       OTHERWISE
          oObj:HandleEvent( nEvent, mp1, mp2 )
       ENDCASE
   ENDDO

   oThread:setInterval(NIL)
   oDlg:Destroy()

RETURN

* ------------------------------------------------------------------------- *

CLASS Banner
PROTECTED:

   VAR oParent                                   //
   VAR aSavePos
   VAR aSaveSize
   VAR oWorkPS                                   // Pressspace
   VAR aMovePos                                  // animation Position

   METHOD FillBG()

EXPORTED:

   VAR xBanner
   VAR xLogo
   VAR xPic

   METHOD init()
   METHOD Create()
   METHOD Destroy()

   METHOD GetBG()                                // get empty Banner
   METHOD Play()                                 // play animation

ENDCLASS

* ------------------------------------------------------------------------- *

METHOD Banner:init(oParent, oOwner, aPos, aSize, aPP, lVisible )

DEFAULT aPP TO {{XBP_PP_BGCLR,XBPSYSCLR_TRANSPARENT}}

   IF !EMPTY(oParent)
      ::oParent := oParent
   ENDIF

   ::aMovePos  := { 0,0 }
   ::aSavePos  := { 0,0 }
   ::aSaveSize := { 0,0 }

   IF !EMPTY(aPos)
      ::aSavePos  := ACLONE(aPos)
   ENDIF
   IF !EMPTY(aSize)
      ::aSaveSize := ACLONE(aSize)
      ::aMovePos  := ACLONE(aSize)               // start right to left
   ENDIF

RETURN Self

* ------------------------------------------------------------------------- *

METHOD Banner:Create(oParent, oOwner, aPos, aSize, aPP, lVisible )

   IF !EMPTY(oParent)
      ::oParent := oParent
   ENDIF

   IF !EMPTY(aPos)
      ::aSavePos  := ACLONE(aPos)
   ENDIF
   IF !EMPTY(aSize)
      ::aSaveSize := ACLONE(aSize)
      ::aMovePos  := ACLONE(aSize)               // start right to left
   ENDIF

RETURN Self

* ------------------------------------------------------------------------- *

METHOD Banner:Destroy()

   ::oWorkPS:destroy()

RETURN Self

* ------------------------------------------------------------------------- *

METHOD Banner:Play(nStep)
LOCAL lSave := .F.
LOCAL oPS
LOCAL cFile
LOCAL aSourceRect[4], aTargetRect

STATIC nCount := 0

DEFAULT nStep TO 10

*ALTD()

   IF EMPTY(::xPic)
      Msgbox("no Image for ::xPic")
      RETURN .F.
   ELSE
      IF ::xPic:xSize > 0 .AND. ::xPic:ySize > 0
         ::xPic:TransparentClr := ::xPic:GetDefaultBGColor()
      ELSE
         Msgbox("Image ::xPic Size are 0 ?")
         RETURN .F.
      ENDIF
   ENDIF

   // get fresh Banner
   ::FillBG()

   self:aSaveSize[1] := ::xBanner:xSize
   self:aSaveSize[2] := ::xBanner:ySize

   // assign Presspace
   ::xBanner:presSpace(::oWorkPS)

   // draw Banner as 1st Image
   ::xBanner:draw(::oWorkPS,{0,0,self:aSaveSize[1],self:aSaveSize[2]} )


   // Counter
   nCount++

   // save every 10th
   IF (nCount % 10) == 0
      lSave := .T.
   ELSE
      lSave := .F.
   ENDIF

   // DEBUG save empty Background
   IF lSave = .T.
      cFile := "Back"+STRZERO(nCount,4)+".JPG"
*      ::xBanner:saveFile(cFile,XBPBMP_FORMAT_JPG)
   ENDIF

   // next Position
   ::aMovePos[1] -= nStep
   IF ::aMovePos[1]  < ::xPic:xSize * -1
      ::aMovePos[1] := 0
   ENDIF
   IF ::aMovePos[1] = 0
      ::aMovePos := ACLONE(self:aSaveSize)
      nCount  := 0
   ENDIF
   // run on Bottom
   ::aMovePos[2] := 0

   // calc Rect Source
   aSourceRect[1] := aSourceRect[3] := 0
   aSourceRect[2] := aSourceRect[4] := 0
   aSourceRect[3] += ::xPic:xSize
   aSourceRect[4] += ::xPic:ySize

   // calc Rect Target
   aTargetRect    := {::aMovePos[1],::aMovePos[2],;
                      ::aMovePos[1]+::xPic:xSize,::aMovePos[2]+::xPic:ySize}

   // draw 2nd Image
   ::xPic:draw(::oWorkPS,aTargetRect,,GRA_BLT_ROP_SRCCOPY)

   // DEBUG save Banner
   IF lSave = .T.
      cFile := "Ani"+STRZERO(nCount,4)+".JPG"
*      ::xBanner:saveFile(cFile,XBPBMP_FORMAT_JPG)
   ENDIF

   // activate Ownerdrawing without flicker
   ::oParent:invalidateRect()

RETURN self

* ------------------------------------------------------------------------- *

METHOD Banner:FillBG()
LOCAL oTargetPS := XbpPresSpace():new():create()
LOCAL oSourcePS := XbpPresSpace():new():create()
LOCAL aSourceRect[4], aTargetRect[4]

   IF !EMPTY(::xLogo)
      IF ::xLogo:isDerivedFrom( "XbpBitmap" )

         // create new (empty) Presspace
         ::oWorkPS  := XbpPresSpace():new():create()

         // original Logo as Source
         ::xLogo:presSpace(oSourcePS)

         // create empty Banner
         ::xBanner  := XbpBitmap():new():create()
         ::xBanner:TransparentClr := ::xBanner:GetDefaultBGColor()
         ::xBanner:presSpace( oTargetPS )
         ::xBanner:make( self:aSaveSize[1], self:aSaveSize[2] )

         // Calc Rect Source
         aSourceRect[1] := aSourceRect[3] := self:aSavePos[1]
         aSourceRect[2] := aSourceRect[4] := self:aSavePos[2]
         aSourceRect[3] += self:aSaveSize[1]
         aSourceRect[4] += self:aSaveSize[2]

         // Calc Rect Target
         aTargetRect    := {0, 0, self:aSaveSize[1], self:aSaveSize[2]}

         // BitBlt into Banner
         GraBitBlt( oTargetPS, oSourcePS, aTargetRect, aSourceRect )

         SLEEP(1)

         // clean up
         oTargetPS:destroy()
         oSourcePS:destroy()

*         ::xBanner:saveFile("Back1.JPG",XBPBMP_FORMAT_JPG)

      ENDIF
   ENDIF

RETURN ::xBanner

* ------------------------------------------------------------------------- *

METHOD Banner:GetBG()
   ::FillBG()
RETURN ::xBanner

* ------------------------------------------------------------------------- *

FUNCTION Test1(oPS, aInfo, oSelf,oBanner)
LOCAL lSave := .F.
LOCAL nStep := 10
LOCAL cFile
LOCAL aSourceRect[4], aTargetRect
LOCAL xBanner
LOCAL aRect

STATIC nCount := 0
STATIC oLast  := NIL

   IF EMPTY(oPS)
      msgbox("Draw"+CRLF+VAR2CHAR(oPS)+CRLF+VAR2CHAR(aInfo)+CRLF+VAR2CHAR(oSelf)+CRLF+VAR2CHAR(oBanner) )
      QUIT
   ENDIF

   IF IsMemberVar(oBanner,"xBanner")
      xBanner  := oBanner:xBanner

      IF VALTYPE(xBanner) = "O"
         IF xBanner:isDerivedFrom( "XbpBitmap" )

            IF oLast  = xBanner
            ELSE
               oLast := xBanner

               nCount++
               IF (nCount % 10) == 0
                  lSave := .T.
               ELSE
                  lSave := .F.
               ENDIF

               aRect := aInfo[XBP_DRAWINFO_RECT]
               xBanner:draw(oPS,aRect)

               IF lSave = .T.
                  cFile := "ttt"+STRZERO(nCount,4)+".JPG"
*                  xBanner:saveFile(cFile,XBPBMP_FORMAT_JPG)
               ENDIF
            ENDIF

         ENDIF
      ENDIF
   ENDIF

RETURN .F.     // must be .F. for Ownerdraw !!!

*
* eof
*